#include "libgraph.h"
#include "image.h"
#include <alloc.h>
#include <memory.h>

value caml_gr_dump_image(value image)
{
  int width, height, i, j;
  value m = Val_unit;

  Begin_roots2(image, m);
    caml_gr_check_open();
    width = Width_im(image);
    height = Height_im(image);
    m = caml_alloc(height, 0);
    for (i = 0; i < height; i++) {
      value v = caml_alloc(width, 0);
      caml_modify(&Field(m, i), v);
    }
	char* data =(char*)Data_im(image);
	for (i = 0; i <height; i++)
	{
		for (j = 0; j <width; j++)
		{
			int r, g, b, t;
			r = *data++ & 0xff;
			g = *data++ & 0xff;
			b = *data++ & 0xff;
			t = *data++ & 0xff;
			if (t)
			{
				Field(Field(m, i), j) = Val_int((r << 16) + (g << 8) + b);
			}
			else
			{
				Field(Field(m, i), j) = Val_int(-1);
			}
		}
	}
  End_roots();
  return m;
}
